<?php

namespace Cabag\SqlScheduler\Command;


/***************************************************************
 *  Copyright notice
 *
 *  (c) 2016 Tizian Schmidlin <st@cabag.ch>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Mvc\Controller\CommandController

class SqlSchedulerCommandController extends CommandController {


  /**
   * The SQL Scheduler command.
   * This allows you to schedule an SQL command at any given time. You could use this
   * to schedule certain SQL commands, like OPTIMIZE on certain tables for easier
   * maintenance.
   *
   * WARNING: You set up this scheduled task as an administrator, so it is assumed, that
   * you know how SQL works and that everything you tell this script to do will be done
   * without questionning what was written, so ensure that your SQL doesn't drop your
   * database or something like this. Also, this will only be able to do what your
   * default mysql user does, if special rights are needed, consider an other solution.
   *
   * @param string $query The query to execute. Seprate multiple queries with semicolons (;)
   */
  public function sqlSchedulerCommand($query) {
    foreach(explode(';', $query) as $singleQuery) {
      $this->getDatabaseConnection()->sql_query($query);
    }
    return true;
  }

  /**
   * Return the database connection
   *
   * @return TYPO3\CMS\Core\Database\DatabaseConnection
   */
  protected getDatabaseConnection() {
    return $GLOBALS['TYPO3_DB'];
  }

}
