<?php
namespace Cabag\SqlScheduler\Task;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2016 Tizian Schmidlin <st@cabag.ch>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

use \TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Core\Bootstrap;
use TYPO3\CMS\Extbase\Service\TypoScriptService;
use TYPO3\CMS\Frontend\Controller\TypoScriptFrontendController;
use TYPO3\CMS\Frontend\Utility\EidUtility;

class SqlSchedulerTask extends tx_scheduler_Task {

  /**
  * SQL query to be executed
  * with
  * the system.
  *
  * @var string
  */
  public $sqlquery = NULL;

  /**
  * Executes the SqlSchedulerTask
  *
  * @see \TYPO3\CMS\Scheduler\Task\AbstractTask::execute()
  */
  public function execute() {
  	if (strpos($this->getSqlquery(), ';')) {
  	    $sqlquery = explode(';', $this->getSqlquery());
  	} else {
  	    $sqlquery = array($this->getSqlquery());
  	}
  	foreach ($sqlquery as $query) {
      $query = trim($query);
      if (!empty($query)) {
    		if (!strpos($query, ';')) {
    		    $query = $query . ';';
    		}
  		$res = $GLOBALS['TYPO3_DB']->sql_query($query);
      }
    }
	return true;
  }

    /**
     * Gets the sql query.
     *
     * @return string SQL query.
     */
    public function getSqlquery() {
	return $this->sqlquery;
    }

    /**
     * Sets the sql query.
     *
     * @param string $notificationEmail SQL query.
     * @return void

     */
    public function setSqlquery($sqlquery) {
	$this->sqlquery = $sqlquery;
    }

}
